import java.io.*;
import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;
import javax.xml.parsers.SAXParserFactory;  
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class SAXSample
{
    public static void main( String[] args )
    {
        try
        {
            File file = new File( "book.xml" );
            if( !file.exists() )
            {
                System.out.println( "Couldn't find file..." );
                return;
            }

            // Use the default (non-validating) parser
            SAXParserFactory factory = SAXParserFactory.newInstance();

            // Create an instance of our handler
            MyHandler handler = new MyHandler();

            // Parse the file 
            SAXParser saxParser = factory.newSAXParser();
            saxParser.parse( file, handler );
            SAXBooks books = handler.getBooks();

            for( int i=0; i<books.getBookSize(); i++ )
            {
                SAXBook book = books.getBook( i );
                System.out.println( book ); 
            }

        } catch( Throwable t )
        {
            t.printStackTrace();
        }
    }
}
