package localhost_8080.wsif.TimeServer;
/**
 * Run test of ports for TimeServer using generated stubs.
 */

import localhost_8080.wsif.TimeServer.*;

public class StubTimeServerClient {

    public static final String DEFAULT_PORT = "TimeServiceSOAPPort";
    public static final String DEFAULT_TIME_ZONE = "Africa/Nairobi";

    public static void main(String[] args) {

        String portName = null;
        String timeZone = null;
        if (args.length == 0) {
            // Default port
            portName = DEFAULT_PORT;
            timeZone = DEFAULT_TIME_ZONE;
        } else if (args.length == 1) {
            portName = args[0];
            timeZone = DEFAULT_TIME_ZONE;
        } else if (args.length == 2) {
            portName = args[0];
            timeZone = args[1];
        } else {
            String className = StubTimeServerClient.class.getName();
            System.err.println("Usage: java " + className + " [portName] [timeZone]");
            System.err.println(
                "Eg: java "
                    + className
                    + " TimeServiceSOAPPort \t- Tests both synchronizeTime() and getTimeAtCity() methods using the SOAP port");
            System.err.println("Default port is " + DEFAULT_PORT);
            System.err.println("Default time zone is " + DEFAULT_TIME_ZONE);
            System.exit(0);
        }

        try {
            TimeServicePortTypeStub timeSvcPortTypeStub =
                new TimeServicePortTypeStub(null, null);
            timeSvcPortTypeStub.selectPort(portName);
            System.out.println(
                "Results of port "
                    + portName
                    + " calling synchronizeTime()="
                    + timeSvcPortTypeStub.synchronizeTime());
            System.out.println(
                "Results of port "
                    + portName
                    + " calling getTimeAtCity(\""
                    + timeZone
                    + "\")="
                    + timeSvcPortTypeStub.getTimeAtCity(timeZone));

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}